/*
    framework jex
    lexical analyzer
    author: Matthias Zenger, Christoph Zenger
    date: 27.02.2000
*/ 

package jex;

import java.io.*;


final class Position {
    
/** undefined position
 */
	public static final int UNDEFINED = 0;

/** first position in a source file
 */
	public static final int FIRST = (1 << 12) | 1;

/** encode a line and column number into a single int
 */
	public static int encode(int line, int col) {
		return (line << 12) | (col & 0xfff);
	}

/** get the line number out of an encoded position
 */
	public static int line(int pos) {
		return pos >>> 12;
	}

/** return the column number of an encoded position
 */
	public static int column(int pos) {
		return pos & 0xfff;
	}
        
        public static String posToString(int pos) {
            if (pos == UNDEFINED) 
                return "";
            else
                return line(pos) + "." + column(pos);
        }
}
